VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3570
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7440
   LinkTopic       =   "Form1"
   ScaleHeight     =   3570
   ScaleWidth      =   7440
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstFields 
      Height          =   1500
      IntegralHeight  =   0   'False
      ItemData        =   "Form1.frx":0000
      Left            =   0
      List            =   "Form1.frx":0019
      MultiSelect     =   2  'Extended
      TabIndex        =   2
      Top             =   0
      Width           =   1095
   End
   Begin MSFlexGridLib.MSFlexGrid flxResults 
      Height          =   2415
      Left            =   2400
      TabIndex        =   1
      Top             =   600
      Visible         =   0   'False
      Width           =   4935
      _ExtentX        =   8705
      _ExtentY        =   4260
      _Version        =   393216
      AllowUserResizing=   1
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "Execute"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   1560
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_DBConnection As ADODB.Connection
Private Sub cmdExecute_Click()
Dim query As String
Dim i As Integer
Dim db_name As String
Dim connect_string As String
Dim rs As ADODB.Recordset
Dim r As Integer
Dim c As Integer
Dim num_cols As Integer
Dim col_wid() As Single
Dim new_wid As Single

    ' Get the list of fields selected.
    For i = 0 To lstFields.ListCount - 1
        If lstFields.Selected(i) Then
            query = query & lstFields.List(i) & ", "
        End If
    Next i

    ' Remove the final comma.
    query = Left$(query, Len(query) - 2)

    ' Build the query.
    query = "SELECT " & query & " FROM Books"

    ' Get the database name.
    db_name = App.Path
    If Right$(db_name, 1) <> "\" Then db_name = db_name & "\"
    db_name = db_name & "books.mdb"

    ' Build the connect string.
    connect_string = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & db_name & ";" & _
        "Persist Security Info=False"

    ' Open the recordset.
    Set rs = New ADODB.Recordset
    rs.Open query, connect_string, _
        adOpenForwardOnly, adLockReadOnly, _
        adCmdText

    ' Hide the grid.
    flxResults.Visible = False
    DoEvents

    ' Display the results.
    If rs.EOF Then
        flxResults.Rows = 1
        flxResults.Cols = 1
        flxResults.TextMatrix(0, 0) = "No Records Selected"
        num_cols = 1
        ReDim col_wid(0 To 0)
        col_wid(0) = TextWidth(flxResults.TextMatrix(0, 0))
    Else
        ' Make room for column widths.
        num_cols = rs.Fields.Count
        ReDim col_wid(0 To num_cols - 1)

        ' Set column headers.
        flxResults.Rows = 2
        flxResults.Cols = num_cols
        flxResults.FixedCols = 0
        flxResults.FixedRows = 1
        For c = 0 To num_cols - 1
            flxResults.TextMatrix(0, c) = rs.Fields(c).Name

            ' See if we need to enlarge the column.
            new_wid = TextWidth(rs.Fields(c).Name)
            If col_wid(c) < new_wid Then col_wid(c) = new_wid
        Next c

        ' Display the data.
        Do Until rs.EOF
            r = r + 1
            flxResults.Rows = r + 1
            For c = 0 To rs.Fields.Count - 1
                flxResults.TextMatrix(r, c) = rs.Fields(c).Value

                ' See if we need to enlarge the column.
                new_wid = TextWidth(rs.Fields(c).Value)
                If col_wid(c) < new_wid Then col_wid(c) = new_wid
            Next c
            rs.MoveNext
        Loop
    End If

    ' Set the grid's column widths.
    For c = 0 To num_cols - 1
        flxResults.ColWidth(c) = col_wid(c) + 120
    Next

    ' Display the grid.
    flxResults.Visible = True

    rs.Close
End Sub


' Make the grid control as large as possible.
Private Sub Form_Resize()
Dim wid As Single

    wid = ScaleWidth - lstFields.Width
    If wid < 120 Then wid = 120
    flxResults.Move lstFields.Width, 0, _
        wid, ScaleHeight
End Sub
' Close the database.
Private Sub Form_Unload(Cancel As Integer)
    If Not m_DBConnection Is Nothing Then
        m_DBConnection.Close
    End If
End Sub


Private Sub lstFields_Click()
    cmdExecute.Enabled = (lstFields.SelCount > 0)
End Sub


